
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>myEvent.js javascript跨浏览器事件框架_javascript技巧 / iVAN</title>

    <meta name="description" content="myEvent.js javascript跨浏览器事件框架_javascript技巧 event究竟有多么复杂?可见前辈的6年前的努力:最佳的addEvent是怎样诞生的,后起之秀jQuery也付出了一千六百多行血汗代码(v 1.5.1)搞定了6年后出现的各种核的浏览器. 我参考前辈的代码以及自己的理解尝试写了一个事件框架,我的框架完成了一个事件机制的核心,它能提供统一接口实现多事件绑定以及避免内存泄漏等其他一些问题,更重要的是性能还不错. 我的手法: 所有回调函数根据元素.事件类型.回调函数唯一ID缓存在一个_create对象中(其内部具体结构可见下面源码的关于_cache的注">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">myEvent.js javascript跨浏览器事件框架_javascript技巧</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>event究竟有多么复杂？可见前辈的6年前的努力：最佳的addEvent是怎样诞生的，后起之秀jQuery也付出了一千六百多行血汗代码（v 1.5.1）搞定了6年后出现的各种核的浏览器。</p>
<p>我参考前辈的代码以及自己的理解尝试写了一个事件框架，我的框架完成了一个事件机制的核心，它能提供统一接口实现多事件绑定以及避免内存泄漏等其他一些问题，更重要的是性能还不错。</p>
<p><strong>我的手法：</strong></p>
<p>所有回调函数根据元素、事件类型、回调函数唯一ID缓存在一个_create对象中（其内部具体结构可见下面源码的关于_cache的注释）。 <br />事件绑定使用一个_create代理函数处理，并且一个元素的各类型事件全部通过此进行分发，同时运用apply方法让IE的指针指向元素。 <br />通过数组队列解决IE回调函数执行顺序的问题。 <br />fix函数将处理回调函数传入的event参数以及其他兼容问题。此处参考了jQuery.event.fix。 <br />断开事件与元素的循环引用避免内存泄漏。 <br /><strong>一、核心实现： <br /></strong><br />
<u>复制代码</u> 代码如下:</p>
<p>// myEvent 0.2 <br />// 2011.04.06 - TangBin - planeart.cn - MIT Licensed <br />/** <br />* 事件框架 <br />* @namespace <br />* @see http://www.planeart.cn/?p=1285 <br />*/ <br />var myEvent = (function () { <br />var _fid = 1, <br />_guid = 1, <br />_time = (new Date).getTime(), <br />_nEid = '{$eid}' + _time, <br />_nFid = '{$fid}' + _time, <br />_DOM = document.addEventListener, <br />_noop = function () {}, <br />_create = function (guid) { <br />return function (event) { <br />event = api.fix(event || window.event); <br />var i = 0, <br />type = (event || (event = document.event)).type, <br />elem = _cache[guid].elem, <br />data = arguments, <br />events = _cache[guid].events[type]; <br />for (; i &lt; events.length; i ++) { <br />if (events[i].apply(elem, data) === false) event.preventDefault(); <br />}; <br />}; <br />}, <br />_cache = {/* <br />1: { <br />elem: (HTMLElement), <br />events: { <br />click: [(Function), (..)], <br />(..) <br />}, <br />listener: (Function) <br />}, <br />(..) <br />*/}; <br />var api = { <br />/** <br />* 事件绑定 <br />* @param {HTMLElement} 元素 <br />* @param {String} 事件名 <br />* @param {Function} 要绑定的函数 <br />*/ <br />bind: function (elem, type, callback) { <br />var guid = elem[_nEid] || (elem[_nEid] = _guid ++); <br />if (!_cache[guid]) _cache[guid] = { <br />elem: elem, <br />listener: _create(guid), <br />events: {} <br />}; <br />if (type &amp;&amp; !_cache[guid].events[type]) { <br />_cache[guid].events[type] = []; <br />api.add(elem, type, _cache[guid].listener); <br />}; <br />if (callback) { <br />if (!callback[_nFid]) callback[_nFid] = _fid ++; <br />_cache[guid].events[type].push(callback); <br />} else <br />return _cache[guid]; <br />}, <br />/** <br />* 事件卸载 <br />* @param {HTMLElement} 元素 <br />* @param {String} 事件名 <br />* @param {Function} 要卸载的函数 <br />*/ <br />unbind: function (elem, type, callback) { <br />var events, i, list, <br />guid = elem[_nEid], <br />handler = _cache[guid]; <br />if (!handler) return; <br />events = handler.events; <br />if (callback) { <br />list = events[type]; <br />if (!list) return; <br />for (i = 0; i &lt; list.length; i ++) { <br />list[i][_nFid] === callback[_nFid] &amp;&amp; list.splice(i--, 1); <br />}; <br />if (list.length === 0) return api.unbind(elem, type); <br />} else if (type) { <br />delete events[type]; <br />api.remove(elem, type, handler.listener); <br />} else { <br />for (i in events) { <br />api.remove(elem, i, handler.listener); <br />}; <br />delete _cache[guid]; <br />}; <br />}, <br />/** <br />* 事件触发 (注意：不会触发浏览器默认行为与冒泡) <br />* @param {HTMLElement} 元素 <br />* @param {String} 事件名 <br />* @param {Array} (可选)附加数据 <br />*/ <br />triggerHandler: function (elem, type, data) { <br />var guid = elem[_nEid], <br />event = { <br />type: type, <br />target: elem, <br />currentTarget: elem, <br />preventDefault: _noop, <br />stopPropagation: _noop <br />}; <br />data = data || []; <br />data.unshift(event); <br />guid &amp;&amp; _cache[guid].listener.apply(elem, data); <br />try { <br />elem['on' + type] &amp;&amp; elem['on' + type].apply(elem, data); <br />//elem[type] &amp;&amp; elem[type](); <br />} catch (e) {}; <br />}, <br />// 原生事件绑定接口 <br />add: _DOM ? function (elem, type, listener) { <br />elem.addEventListener(type, listener, false); <br />} : function (elem, type, listener) { <br />elem.attachEvent('on' + type, listener); <br />}, <br />// 原生事件卸载接口 <br />remove: _DOM ? function (elem, type, listener) { <br />elem.removeEventListener(type, listener, false); <br />} : function (elem, type, listener) { <br />elem.detachEvent('on' + type, listener); <br />}, <br />// 修正 <br />fix: function (event) { <br />if (_DOM) return event; <br />var name, <br />newEvent = {}, <br />doc = document.documentElement, <br />body = document.body; <br />newEvent.target = event.srcElement || document; <br />newEvent.target.nodeType === 3 &amp;&amp; (newEvent.target = newEvent.target.parentNode); <br />newEvent.preventDefault = function () {event.returnValue = false}; <br />newEvent.stopPropagation = function () {event.cancelBubble = true}; <br />newEvent.pageX = newEvent.clientX + (doc &amp;&amp; doc.scrollLeft || body &amp;&amp; body.scrollLeft || 0) - (doc &amp;&amp; doc.clientLeft || body &amp;&amp; body.clientLeft || 0); <br />newEvent.pageY = newEvent.clientY + (doc &amp;&amp; doc.scrollTop || body &amp;&amp; body.scrollTop || 0) - (doc &amp;&amp; doc.clientTop || body &amp;&amp; body.clientTop || 0); <br />newEvent.relatedTarget = event.fromElement === newEvent.target ? event.toElement : event.fromElement; <br />// !!IE写event会极其容易导致内存泄漏，Firefox写event会报错 <br />// 拷贝event <br />for (name in event) newEvent[name] = event[name]; <br />return newEvent; <br />} <br />}; <br />return api; <br />})();</p>
<p>我给一万个元素绑定事件进行了测试，测试工具为sIEve，结果：<br />
<table>
<tbody>
<tr>
<td>事件框架</td>
<td>耗时</td>
<td>内存</td>
</tr>
<tr>
<td colspan="3">IE8</td>
</tr>
<tr>
<td>jQuery.bind</td>
<td>1064 MS</td>
<td>79.80 MB</td>
</tr>
<tr>
<td>myEvent.bind</td>
<td>623 MS</td>
<td>35.82 MB</td>
</tr>
<tr>
<td colspan="3">IE6</td>
</tr>
<tr>
<td>jQuery.bind</td>
<td>2503 MS</td>
<td>74.23 MB</td>
</tr>
<tr>
<td>myEvent.bind</td>
<td>1810 MS</td>
<td>28.48 MB</td>
</tr>
</tbody>
</table>
<p>可以看到无论是执行效率还是内存占用myEvent都比有一定优势，这是可能是由于jQuery事件机制过于强大导致其性能的损耗。<br />测试样本：http://www.planeart.cn/demo/myEvent/</p>
<p><strong>二、扩展自定义事件机制</strong><br />jQuery是可以自定义事件的，它用一个special命名空间存储自定义事件，我在上面代码的基础上模仿jQuery自定义事件机制，并把其著名的ready事件与另外一个jQuery hashchange事件插件移植过来。</p>
<p>这两个自定义事件非常重要，ready事件可以在DOM就绪给元素绑定事件，比传统使用window.onload要快很多；hashchange事件可以监听锚点改变，常用于解决AJAX历史记录问题，如Twitter新版本就就采用此处理AJAX，使用锚点机制除了可以提高AJAX应用程序的用户体验外，如果按照一定规则还能被google索引到。</p>
<p>当然，我前面文章实现的imgReady事件也可以通过此扩展进来，稍后更新。</p>
<p><u>复制代码</u> 代码如下:</p>
<p>// myEvent 0.2.2 <br />// 2011.04.07 - TangBin - planeart.cn - MIT Licensed <br />/** <br />* 事件框架 <br />* @namespace <br />* @see http://www.planeart.cn/?p=1285 <br />*/ <br />var myEvent = (function () { <br />var _ret, _name, <br />_fid = 1, <br />_guid = 1, <br />_time = (new Date).getTime(), <br />_nEid = '{$eid}' + _time, <br />_nFid = '{$fid}' + _time, <br />_DOM = document.addEventListener, <br />_noop = function () {}, <br />_create = function (guid) { <br />return function (event) { <br />event = myEvent.fix(event || window.event); <br />var type = (event || (event = document.event)).type, <br />elem = _cache[guid].elem, <br />data = arguments, <br />events = _cache[guid].events[type], <br />i = 0, <br />length = events.length; <br />for (; i &lt; length; i ++) { <br />if (events[i].apply(elem, data) === false) event.preventDefault(); <br />}; <br />event = elem = null; <br />}; <br />}, <br />_cache = {/* <br />1: { <br />elem: (HTMLElement), <br />events: { <br />click: [(Function), (..)], <br />(..) <br />}, <br />listener: (Function) <br />}, <br />(..) <br />*/}; <br />var API = function () {}; <br />API.prototype = { <br />/** <br />* 事件绑定 <br />* @param {HTMLElement} 元素 <br />* @param {String} 事件名 <br />* @param {Function} 要绑定的函数 <br />*/ <br />bind: function (elem, type, callback) { <br />var events, listener, <br />guid = elem[_nEid] || (elem[_nEid] = _guid ++), <br />special = this.special[type] || {}, <br />cacheData = _cache[guid]; <br />if (!cacheData) cacheData = _cache[guid] = { <br />elem: elem, <br />listener: _create(guid), <br />events: {} <br />}; <br />events = cacheData.events; <br />listener = cacheData.listener; <br />if (!events[type]) events[type] = []; <br />if (!callback[_nFid]) callback[_nFid] = _fid ++; <br />if (!special.setup || special.setup.call(elem, listener) === false) { <br />events[type].length === 0 &amp;&amp; this.add(elem, type, listener); <br />}; <br />events[type].push(callback); <br />}, <br />/** <br />* 事件卸载 <br />* @param {HTMLElement} 元素 <br />* @param {String} 事件名 <br />* @param {Function} 要卸载的函数 <br />*/ <br />unbind: function (elem, type, callback) { <br />var events, special, i, list, fid, <br />guid = elem[_nEid], <br />cacheData = _cache[guid]; <br />if (!cacheData) return; <br />events = cacheData.events; <br />if (callback) { <br />list = events[type]; <br />fid = callback[_nFid]; <br />if (!list) return; <br />for (i = 0; i &lt; list.length; i ++) { <br />list[i][_nFid] === fid &amp;&amp; list.splice(i--, 1); <br />}; <br />if (!list.length) this.unbind(elem, type); <br />} else if (type) { <br />special = this.special[type] || {}; <br />if (!special.teardown || special.teardown.call(elem) === false) { <br />this.remove(elem, type, cacheData.listener); <br />}; <br />delete events[type]; <br />} else { <br />for (i in events) { <br />this.remove(elem, i, cacheData.listener); <br />}; <br />delete _cache[guid]; <br />}; <br />}, <br />/** <br />* 事件触发 (注意：不会触发浏览器默认行为与冒泡) <br />* @param {HTMLElement} 元素 <br />* @param {String} 事件名 <br />* @param {Array} (可选)附加数据 <br />*/ <br />triggerHandler: function (elem, type, data) { <br />var guid = elem[_nEid], <br />cacheData = _cache[guid], <br />event = { <br />type: type, <br />target: elem, <br />currentTarget: elem, <br />preventDefault: _noop, <br />stopPropagation: _noop <br />}; <br />data = data || []; <br />data.unshift(event); <br />cacheData &amp;&amp; cacheData.events[type] &amp;&amp; _cache[guid].listener.apply(elem, data); <br />try { <br />elem['on' + type] &amp;&amp; elem['on' + type].apply(elem, data); <br />//elem[type] &amp;&amp; elem[type](); <br />} catch (e) {}; <br />}, <br />// 自定义事件接口 <br />special: {}, <br />// 原生事件绑定接口 <br />add: _DOM ? function (elem, type, listener) { <br />elem.addEventListener(type, listener, false); <br />} : function (elem, type, listener) { <br />elem.attachEvent('on' + type, listener); <br />}, <br />// 原生事件卸载接口 <br />remove: _DOM ? function (elem, type, listener) { <br />elem.removeEventListener(type, listener, false); <br />} : function (elem, type, listener) { <br />elem.detachEvent('on' + type, listener); <br />}, <br />// 修正 <br />fix: function (event) { <br />if (_DOM) return event; <br />var name, <br />newEvent = {}, <br />doc = document.documentElement, <br />body = document.body; <br />newEvent.target = event.srcElement || document; <br />newEvent.target.nodeType === 3 &amp;&amp; (newEvent.target = newEvent.target.parentNode); <br />newEvent.preventDefault = function () {event.returnValue = false}; <br />newEvent.stopPropagation = function () {event.cancelBubble = true}; <br />newEvent.pageX = newEvent.clientX + (doc &amp;&amp; doc.scrollLeft || body &amp;&amp; body.scrollLeft || 0) - (doc &amp;&amp; doc.clientLeft || body &amp;&amp; body.clientLeft || 0); <br />newEvent.pageY = newEvent.clientY + (doc &amp;&amp; doc.scrollTop || body &amp;&amp; body.scrollTop || 0) - (doc &amp;&amp; doc.clientTop || body &amp;&amp; body.clientTop || 0); <br />newEvent.relatedTarget = event.fromElement === newEvent.target ? event.toElement : event.fromElement; <br />// !!直接写event IE导致内存泄漏，Firefox会报错 <br />// 伪装event <br />for (name in event) newEvent[name] = event[name]; <br />return newEvent; <br />} <br />}; <br />return new API(); <br />})(); <br />// DOM就绪事件 <br />myEvent.ready = (function () { <br />var readyList = [], DOMContentLoaded, <br />readyBound = false, isReady = false; <br />function ready () { <br />if (!isReady) { <br />if (!document.body) return setTimeout(ready, 13); <br />isReady = true; <br />if (readyList) { <br />var fn, i = 0; <br />while ((fn = readyList[i++])) { <br />fn.call(document, {}); <br />}; <br />readyList = null; <br />}; <br />}; <br />}; <br />function bindReady () { <br />if (readyBound) return; <br />readyBound = true; <br />if (document.readyState === 'complete') { <br />return ready(); <br />}; <br />if (document.addEventListener) { <br />document.addEventListener('DOMContentLoaded', DOMContentLoaded, false); <br />window.addEventListener('load', ready, false); <br />} else if (document.attachEvent) { <br />document.attachEvent('onreadystatechange', DOMContentLoaded); <br />window.attachEvent('onload', ready); <br />var toplevel = false; <br />try { <br />toplevel = window.frameElement == null; <br />} catch (e) {}; <br />if (document.documentElement.doScroll &amp;&amp; toplevel) { <br />doScrollCheck(); <br />}; <br />}; <br />}; <br />myEvent.special.ready = { <br />setup: bindReady, <br />teardown: function () {} <br />}; <br />if (document.addEventListener) { <br />DOMContentLoaded = function () { <br />document.removeEventListener('DOMContentLoaded', DOMContentLoaded, false); <br />ready(); <br />}; <br />} else if (document.attachEvent) { <br />DOMContentLoaded = function () { <br />if (document.readyState === 'complete') { <br />document.detachEvent('onreadystatechange', DOMContentLoaded); <br />ready(); <br />}; <br />}; <br />}; <br />function doScrollCheck () { <br />if (isReady) return; <br />try { <br />document.documentElement.doScroll('left'); <br />} catch (e) { <br />setTimeout(doScrollCheck, 1); <br />return; <br />}; <br />ready(); <br />}; <br />return function (callback) { <br />bindReady(); <br />if (isReady) { <br />callback.call(document, {}); <br />} else if (readyList) { <br />readyList.push(callback); <br />}; <br />return this; <br />}; <br />})(); <br />// Hashchange Event v1.3 <br />(function (window, undefined) { <br />var config = { <br />delay: 50, <br />src: null, <br />domain: null <br />}, <br />str_hashchange = 'hashchange', <br />doc = document, <br />isIE = !-[1,], <br />fake_onhashchange, special = myEvent.special, <br />doc_mode = doc.documentMode, <br />supports_onhashchange = 'on' + str_hashchange in window &amp;&amp; (doc_mode === undefined || doc_mode &gt; 7); <br />function get_fragment(url) { <br />url = url || location.href; <br />return '#' + url.replace(/^[^#]*#?(.*)$/, '$1'); <br />}; <br />special[str_hashchange] = { <br />setup: function () { <br />if (supports_onhashchange) return false; <br />myEvent.ready(fake_onhashchange.start); <br />}, <br />teardown: function () { <br />if (supports_onhashchange) return false; <br />myEvent.ready(fake_onhashchange.stop); <br />} <br />}; <br />/** @inner */ <br />fake_onhashchange = (function () { <br />var self = {}, <br />timeout_id, last_hash = get_fragment(), <br />/** @inner */ <br />fn_retval = function (val) { <br />return val; <br />}, <br />history_set = fn_retval, <br />history_get = fn_retval; <br />self.start = function () { <br />timeout_id || poll(); <br />}; <br />self.stop = function () { <br />timeout_id &amp;&amp; clearTimeout(timeout_id); <br />timeout_id = undefined; <br />}; <br />function poll() { <br />var hash = get_fragment(), <br />history_hash = history_get(last_hash); <br />if (hash !== last_hash) { <br />history_set(last_hash = hash, history_hash); <br />myEvent.triggerHandler(window, str_hashchange); <br />} else if (history_hash !== last_hash) { <br />location.href = location.href.replace(/#.*/, '') + history_hash; <br />}; <br />timeout_id = setTimeout(poll, config.delay); <br />}; <br />isIE &amp;&amp; !supports_onhashchange &amp;&amp; (function () { <br />var iframe,iframe_src, iframe_window; <br />self.start = function () { <br />if (!iframe) { <br />iframe_src = config.src; <br />iframe_src = iframe_src &amp;&amp; iframe_src + get_fragment(); <br />iframe = doc.createElement('&lt;IFRAME title=empty style="DISPLAY: none" tabIndex=-1 src="' + (iframe_src || 'javascript:0') + '"&gt;&lt;/IFRAME&gt;'); <br />myEvent.bind(iframe, 'load', function () { <br />myEvent.unbind(iframe, 'load'); <br />iframe_src || history_set(get_fragment()); <br />poll(); <br />}); <br />doc.getElementsByTagName('html')[0].appendChild(iframe); <br />iframe_window = iframe.contentWindow; <br />doc.onpropertychange = function () { <br />try { <br />if (event.propertyName === 'title') { <br />iframe_window.document.title = doc.title; <br />}; <br />} catch (e) {}; <br />}; <br />}; <br />}; <br />self.stop = fn_retval; <br />/** @inner */ <br />history_get = function () { <br />return get_fragment(iframe_window.location.href); <br />}; <br />/** @inner */ <br />history_set = function (hash, history_hash) { <br />var iframe_doc = iframe_window.document, <br />domain = config.domain; <br />if (hash !== history_hash) { <br />iframe_doc.title = doc.title; <br />iframe_doc.open(); <br />domain &amp;&amp; iframe_doc.write('&lt;SCRIPT&gt;document.domain="' + domain + '"&lt;/SCRIPT&gt;'); <br />iframe_doc.close(); <br />iframe_window.location.hash = hash; <br />}; <br />}; <br />})(); <br />return self; <br />})(); <br />})(this);</p>
<p>ready事件是伪事件，调用方式：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>myEvent.ready(function () { <br />//[code..] <br />});</p>
<p>hashchange事件可以采用标准方式绑定：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>myEvent.bind(window, 'hashchange', function () { <br />//[code..] <br />});</p>
<p>这里有一些文章值得阅读：<br />javascript 跨浏览器的事件系统(司徒正美。他博客有一系列的讲解)<br />更优雅的兼容（BELLEVE INVIS）</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 11:59:17</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e4%ba%8b%e4%bb%b6%e6%a1%86%e6%9e%b6/" title="事件框架">事件框架</a>, <a href="https://www.iamivan.net/tag/myevent-js/" title="myEvent&period;js">myEvent&period;js</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>myEvent.js javascript跨浏览器事件框架_javascript技巧的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPx0Y8p.html" rel="bookmark">详解javascript跨浏览器事件处理程序&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文为大家分享了javascript跨浏览器事件处理机制,供大家参考,具体内容如下 &lt;!doctype html&gt; &lt;html lang=&quot;en&quot;&gt; &lt;head&gt; &lt;meta charset=&quot;UTF-8&quot;&gt; &lt;title&gt;跨浏览器的事件处理程序&lt;/title&gt; &lt;/head&gt; &lt;body&gt; &lt;input type=&quot;button&quot; value=			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgEgB5z.html" rel="bookmark">css与javascript跨浏览器兼容性总结&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文以大量实例形式总结了css与javascript跨浏览器的兼容性问题.分享给大家供大家参考.具体总结如下: 一.CSS样式兼容性 1. FLOAT闭合(clearing float) 网页在某些浏览器上显示错位很多时候都是因为使用了float浮动而没有真正闭合,这也是div无法自适应高度的一个原因.如果父div没有设float而其子div却设了float的话,父div无法包住整个子DIV,这种情况一般出现在一个父DIV下包含多个子DIV.解决办法: 1) 给父DIV也设上float 2) 在			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MR11Vdb.html" rel="bookmark">javascript高级程序设计第二版第十二章事件要点总结&lpar;常用的跨浏览器检测方法&rpar;&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				复制代码 代码如下: var EventUtil={ //跨浏览器处理程序---创建方法 addHandler:function(element,type,handler){ if(element.addEventListener){ element.addEventListneter(type,handler,false); }else if(element.attachEvent){ element.attachEvent(&quot;on&quot;+type,handler); }else{ el			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0N8jDz.html" rel="bookmark">js 浏览器事件介绍&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				浏览器事件 浏览器事件指载入文档直到该文档被关闭期间的浏览器事件,如浏览器载入文档事件onload.关闭该文档事件onunload.浏览器失去焦点事件onblur.获得焦点事件onfocus 等. 先考察如下的代码: 复制代码 代码如下: //源程序3.1 &lt;! DOCTYPE HTML PUBLIC &quot;-//W3C//DTD HTML 4.0//EN&quot; &quot;http://www.w3.org/TR/REC-html140/strict.dtd&quot;&gt; &lt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqWJO3z.html" rel="bookmark">常见的javascript跨域通信方法&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文主要介绍几种常见的javascript跨域通信方法.首先讲解一下JSONP.1.JSONP JSONP(JSON with Padding)是JSON的一种&quot;使用模式&quot;,可用于解决主流浏览器的跨域数据访问的问题.由于同源策略,一般来说位于 server1.example.com 的网页无法与不是 server1.example.com的服务器沟通,而 HTML 的&lt;script&gt; 元素是一个例外.利用 &lt;script&gt; 元素的这个开放策略,网页可以得到从其他			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mr2NRvM.html" rel="bookmark">浅析javascript中的事件代理&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文的主要内容是根据前不久面试某家公司Web前端开发岗位,面试时做的一道数组去重问题的解题思路进行整理的,分享给大家. 题目本身很简单:一个ul中有一千个li,如何给这一千个li绑定一个鼠标点击事件,当鼠标点击时alert出这个li的内容和li的位置坐标xy, &lt;ul id=&quot;ulItem&quot;&gt; &lt;li id=&quot;li1&quot;&gt;1&lt;/li&gt; &lt;li id=&quot;li2&quot;&gt;2&lt;/li&gt; &lt;li			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgWO2BM.html" rel="bookmark">js识别uc浏览器的代码&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				其实挺简单的就是 if(navigator.userAgent.indexOf('UCBrowser') &gt; -1) { alert(&quot;uc浏览器&quot;); }else{ //不是uc浏览器执行的操作 } 如果想测试某个浏览器的特征可以通过如下方法获取 JS获取浏览器信息 浏览器代码名称:navigator.appCodeName 浏览器名称:navigator.appName 浏览器版本号:navigator.appVersion 对Java的支持:navigator.javaEn			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwWErWz.html" rel="bookmark">Javascript封装DOMContentLoaded事件实例&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近在写一个Javascript的框架,刚把DOMContentLoaded事件封装好,略带小兴奋,把开发过程中遇到的原理和兼容性问题做篇笔记,省的忘记到处找. 我们在写js代码的时候,一般都会添加window.onload事件,主要是为了在DOM加载完后可以使用getElementById,getElementsByTagName等方法选取DOM元素进行操作,但是window.load会等到加载完DOM.脚本.CSS,最后加载完图片甚至是iframe中的所有资源才会触发,很多时候网页的图片较多			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ba67Z2M.html" rel="bookmark">JavaScript跨域方法汇总&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				做Web开发经常需要面对跨域问题,跨域问题的根源是浏览器安全中的同源策略,比如说,对于http://www.a.com/1.html来说: 1.http://www.a.com/2.html是同源的: 2.https://www.a.com/2.html是不同源的,原因是协议不同: 3.http://www.a.com:8080/2.html是不同源的,原因是端口不同: 4.http://sub.a.com/2.html是不同源的,原因是主机不同. 在浏览器中,&lt;script&gt;.&lt;img			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MWqN7z.html" rel="bookmark" class="title">用Visual C＃获得计算机名称和IP地址</a>
					<div>
						ip地址|visual      Visual C#是微软公司推出的下一代程序开发语言,是微软.net 框架中的的一个重要组成部分,在推出Visual C#的过程中,微软公司还推出了与之相对应的一个软 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvxP9z.html" rel="bookmark" class="title">主板常见故障分类及排除方法</a>
					<div>
						主板是PC电脑中集成度最高的配件产品,也是最易出现故障的配件之一.较高的集成度使其维修起来相当麻烦,可维修性越来越低.不过很多时候由主板引起的电脑故障是很容易解决的,只要我们掌握了好的方法,维修起来并 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMA9PJM.html" rel="bookmark" class="title">日志分析工具Awstats的分析结果静态化</a>
					<div>
						前言: Awstats 是在 SourceForge 上发展很快的一个基于 Perl 的 WEB 日志分析工具,一个充分的日志分析让 Awstats 显示您下列资料: 访问次数.独特访客人数, 访问时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1BWez.html" rel="bookmark" class="title">vs2008下C&plus;&plus;对象内存布局（2）：简单继承</a>
					<div>
						这次我们添加一个子类,父类和子类均不带虚函数: class CParent { public: int parent_a; int parent_b; public: void parent_f1() ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyrqRZp.html" rel="bookmark" class="title">Fireworks新手教程：制作五彩炫光效果</a>
					<div>
						1.新建画布600×400,填充黑色 2.设置画笔大小,柔化边缘,用画笔工具在画布中涂画,如图 3.对刚才的图形做运动模糊,设置角度90,距离100,效果如下 4.平面化刚才的图形,通过复制和变形工具 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M915rKM.html" rel="bookmark" class="title">PS教你绘制一枚经典的ITUNES图标</a>
					<div>
						  在Photoshop中,图层样式是最为直观的东西,所有的效果都能量化,以数值的形式表现出来,就是各种晦涩难懂的等高线也可以用数字来表现.利用图层样式中的混合模式可以得到千变万化的效果,很多的UI和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBKRqz.html" rel="bookmark" class="title">js数组循环遍历数组内所有元素的方法</a>
					<div>
						 在js中数组遍历最简单的办法就是使用for然后再利用arr.length长度作为for最大限度值即可解决了,下面我们来看看一些有用的实例 例,for(){}遍历数组  代码如下: &lt;scrip ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7LGvb.html" rel="bookmark" class="title">Office2013联机演示文档怎么使用</a>
					<div>
						  Office2013新推出了一个联机演示文档的功能,只要在联网平台都能观看到我们的演示文档,但是很多人都不知道怎么使用Office2013联机演示文档的功能,只要注册好微软账号把文档生成一个HTT ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5o8L6b.html" rel="bookmark" class="title">WORD怎样设置每页不同的页眉</a>
					<div>
						  找到word软件,并打开 点击&quot;文件&quot; 点击进入&quot;页面设置&quot; 找到&quot;版式&quot;选项并点击 在&quot;页眉页脚&quot;选项中,&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZlW7z.html" rel="bookmark" class="title">使用七牛实现静态页面的上传</a>
					<div>
						对于我们的静态页面来讲,静态页面一般喜欢将js文件.图片归到各自文件夹.不然的话,一般我们就得改变静态页面中js和图片的引用地址.但是在七牛的内容管理页面上传的东西基本上就是在七牛提供的空间的根目录下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjmXB0z.html" rel="bookmark" class="title">&lbrack;MySQL源码&rsqb; Facebook对压缩表的改进</a>
					<div>
						由于公司最近很多地方需要开始有使用压缩表的需求,但根据测试结果,压缩表对OLTP的性能相当不理想,在最近的一次测试中,UPDATE的性能最大可以下降到1/12,几乎不可接受.   Facebook从2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ZnnPb.html" rel="bookmark" class="title">调用didReceiveBuddyRequest无反应</a>
					<div>
						问题描述 调用didReceiveBuddyRequest后   像测试账号发送好友请求,但是无反应 解决方案 这个是回调方法,收到好友请求的时候会触发这个.要声明实现&lt;IChatManager ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKQ7V7p.html" rel="bookmark" class="title">stm32之keil开发环境搭建</a>
					<div>
						只要按照下面的一步步来,绝对能从0开始建立一个STM32工程.不仅包括工程建立过程,还有Jlink设置方法.本文使用芯片为STM32F103CB. 1 下载stm32F10x的官方库 http://w ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrRowM.html" rel="bookmark" class="title">了解Excel公式的错误值</a>
					<div>
						经常用http://www.aliyun.com/zixun/aggregation/16544.html&quot;&gt;Excel的朋友可能都会遇到一些莫名奇妙的错误值信息:# N/A!.#VA ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1lXQ3b.html" rel="bookmark" class="title">oracle重装失败 WIN7下</a>
					<div>
						问题描述 已通过ConfigurationAssistant&quot;OracleNetConfigurationAssistant&quot;生成输出:Command=F:Windowssyste ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGA5KoM.html" rel="bookmark" class="title">天下武功唯快不破 云时代IT基建谋出路</a>
					<div>
						本文讲的是天下武功唯快不破 云时代IT基建谋出路,云计算大行其道.大数据愈演愈烈的今天,人们对于技术的要求已经从单纯的 &quot;满足需求&quot;提高到&quot;全面优化&quot;的高度.而 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkwnqjp.html" rel="bookmark" class="title">知识扩展----404错误页面那些事</a>
					<div>
						     今天浏览网页的时候,当点击网页链接之后,就出现一个错误的页面           对这个东西,貌似有点印象,之前浏览网页的时候,也是经常出现的事,只不过弹出的页面不同罢了.举个例子:     ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8AknZz.html" rel="bookmark" class="title">c&num;写怎么防止并发操作（一个要删文件，一个要读文件）？</a>
					<div>
						问题描述 c#写怎么防止并发操作(一个要删文件,一个要读文件)? c#写web后台文件和数据库操作,怎么防止并发操作(一个要删文件,一个要读文件)? 解决方案 你读文件的时候指定FileShare.R ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXAYvz.html" rel="bookmark" class="title">《开心农场》成功的背后：开发公司月赚300万</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 你没有偷过菜?王骏睁大着眼睛看着记者.称城市白领的王骏最近几个月成了勤勤恳恳的菜农:种菜.收菜,还不时把朋友的菜往自己家里偷.当然,这一切都不是在现实中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRXd0b.html" rel="bookmark" class="title">海润光伏开始恢复元气 谋划开拓东南亚光伏战场</a>
					<div>
						光伏业上市公司海润光伏曾经一度被亏损及财务造假等诸多坏消息压顶,它眼下似乎正慢慢恢复元气.在迎来战略投资新面孔的同时,它还结盟国际新能源业的豪门新贵,试图通过海外市场的突飞猛进来努力摆脱困境. 海润光 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOmD9kM.html" rel="bookmark" class="title">jar包问题-java&period;xx&period;xswing 这个包是什么啊，</a>
					<div>
						问题描述 java.xx.xswing 这个包是什么啊, java.xx.xswing 这个包是什么啊,有没有这个包啊,这个包怎么用啊,从哪儿下载啊,有的发给我 1043489207@qq.com 我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdRaZNb.html" rel="bookmark" class="title">搜索引擎排名背后的逻辑 要让用户想到我们</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 SEO归根结底是跟搜索引擎打交道的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYX9aQb.html" rel="bookmark" class="title">构建ASP&period;NET MVC4&plus;EF5&plus;EasyUI&plus;Unity2&period;x注入的后台管理系统（31）-MVC使用RDL报表</a>
					<div>
						原文:构建ASP.NET MVC4+EF5+EasyUI+Unity2.x注入的后台管理系统(31)-MVC使用RDL报表 这次我们来演示MVC3怎么显示RDL报表,坑爹的微软把MVC升级到5都木有良 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXg15b.html" rel="bookmark" class="title">服务器端如何获得客户端的登录用户名？</a>
					<div>
						问题描述 客户端是用域用户方式登录,想在服务器端能够直接获得客户端用户的登录域用户名,而且不需要客户端再次输入用户名和密码. 解决方案 解决方案二:HttpContext.Current.User.I ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRNaVqM.html" rel="bookmark" class="title">红十字总会开微博回应郭美美事件</a>
					<div>
						本报讯 (记者 王卡拉) 在网民&quot;千呼万唤&quot;下,昨日下午2时多,中国红十字总会获得新浪微博认证,正式开通其官方微博.截至昨晚11时,粉丝已达1.6万. 中国红十字会共发布4条微博, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZBrnaz.html" rel="bookmark" class="title">继秘密之后，乌鸦飞来</a>
					<div>
						伴随着Secret还有他们的&quot;衍生者&quot;的持续火爆,匿名社交应用火热迅速的发展,成为了移动社交领域的一片新红海.而啪啪的创始人许朝军也随之推出一款匿名社交应用产品,名为&quot;乌 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNvqBmM.html" rel="bookmark" class="title">详解JavaScript时间格式化&lowbar;javascript技巧</a>
					<div>
						感谢某前辈写的JS格式化日期和时间JS代码,很好很强大!!! 前言: js虽然提供了各种获取时间Date对象的不同属性方法,如:getDate 方法 | getDay 方法 | getFullYear ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlmrDRp.html" rel="bookmark" class="title">PHP根据两点间的经纬度计算距离&lowbar;php技巧</a>
					<div>
						这是一个不错的示例,直接贴代码,首先要知道纬度值.经度值 /** * @desc 根据两点间的经纬度计算距离 * @param float $lat 纬度值 * @param float $lng 经 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj8VaZp.html" rel="bookmark" class="title">《Android游戏开发详解》一2&period;15　改进程序</a>
					<div>
						2.15 改进程序 Android游戏开发详解让我们记住上面的原理,并且努力地改进程序.首先,添加一个内建的Java关键字private作为所有Phone对象的变量的修饰符,如程序清单2.14第4行到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYdrNVb.html" rel="bookmark" class="title">重磅 &vert; 阿里推出多智能体双向协调网络BicNet，玩《星际争霸》堪比人类</a>
					<div>
						过去十年中,人工智能取得了长足的进步,在图像和语音识别上已经在某种程度上超越了人类.而通过反馈奖励,单个的AI智能体也能在雅达利这样的视频游戏和围棋中战胜人类. 但人类真正的智能还包括了社会和集体智能 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
